package eu.jonahbauer.wizard.core.machine.states.trick;

import eu.jonahbauer.wizard.core.machine.Game;
import eu.jonahbauer.wizard.core.machine.GameData;
import eu.jonahbauer.wizard.core.machine.states.round.RoundState;
import eu.jonahbauer.wizard.core.model.Card;

public abstract class TrickState extends RoundState {
    public TrickState(Game game, GameData data) {
        super(
                game,
                data.requireAllHands()
                    .requireAllPredictions()
                    .requireTrumpSuit()
                    .requireTrick()
                    .requireTricks()
                    .requireCurrentPlayer()
        );
    }

    protected Card.Suit getTrickSuit() {
        for (var pair : getStack()) {
            Card.Suit suit = pair.second().getSuit();
            if (suit == Card.Suit.WIZARD) {
                return Card.Suit.NONE;
            } else if (suit.isColor()) {
                return suit;
            }
        }
        return Card.Suit.NONE;
    }
}
